#!/usr/bin/perl

# (c) vbabin-at-ncsu-dot-edu 2010

use strict;
use warnings;

die "** Error ** : need scale, in and out file names\n"
    unless defined(@ARGV) and scalar @ARGV == 3;

my $scale = shift @ARGV;
my $infile = shift @ARGV;
my $outfile = shift @ARGV;

die "** Error ** : '$infile' does not exist\n" unless -f $infile;

open IH, "ncdump $infile |"
    or die "** Error ** : could not pipe from 'ncdump $infile'\n";
open OH, "| ncgen -o $outfile"
    or die "** Error ** : could not pipe to 'ncgen -o $outfile'\n";

while (<IH>) {
    print OH $_;
    printf OH "                :scale = %f ;\n", $scale
        if (/global\s+attributes/);
    last if /data:/;
}

my $fpre = '[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?';

while (<IH>) {
    # multiply all floats by $scale without touching anything else
    PARSER : {
        m/\G($fpre)/gcx && do { print OH $scale*$1; redo; };
        m/\G(.)/gcx && do { print OH $1; redo; };
    }
    print OH "\n";
}

close OH;
close IH;

print STDERR "<> done scaling of '$infile' to '$outfile' by $scale\n";
